rem SYSRAM1.OPX Test code
rem
rem Copyright (c) 1997-2000 Symbian Ltd. All Rights Reserved.
rem
rem Version 5.20(025) - Last Updated 7 August 2000.

DECLARE EXTERNAL
EXTERNAL tDbFind:
EXTERNAL tDbFindField:
EXTERNAL tGetThreadIdFromCaption:
EXTERNAL tExternalPower:
EXTERNAL tLCNearestLanguageFile:
EXTERNAL tLCLanguage:
EXTERNAL tOsVersionMajor:
EXTERNAL tOsVersionMinor:
EXTERNAL tOsVersionBuild:
EXTERNAL tRomVersionMajor:
EXTERNAL tRomVersionMinor:
EXTERNAL tRomVersionBuild:
EXTERNAL tGetFileSize:
EXTERNAL tDTDayNameFull:
EXTERNAL tDTMonthNameFull:
EXTERNAL tDTIsLeapYear:
EXTERNAL tLCDateSeparator:
EXTERNAL tLCTimeSeparator:
EXTERNAL tLCAmPmSpaceBetween:
EXTERNAL tRunExeCmd:
EXTERNAL tRunDoc:
EXTERNAL tOPXVersion:

INCLUDE "SYSRAM1.OXH"
INCLUDE "CONST.OPH"

CONST KTestFile$="C:\TSysram1.dbf"

proc main:
	print "Testing SYSRAM1 OPX"
	print "-------------------"
	print
	print "Note that this code makes assumptions about what machine the code is running on."
	print "For example it's a UK machine."
	print
	print "This may result in false failures on other machines."
	print

	rem
	rem TESTS BEGIN HERE
	rem

	tDbFind:
	tDbFindField:
	tGetThreadIdFromCaption:
	tExternalPower:
	tLCNearestLanguageFile:
	tLCLanguage:
	tOsVersionMajor:
	tOsVersionMinor:
	tOsVersionBuild:
	tRomVersionMajor:
	tRomVersionMinor:
	tRomVersionBuild:
rem	tGetFileSize:
	tDTDayNameFull:
	tDTMonthNameFull:
	tDTIsLeapYear:
	tLCDateSeparator:
	tLCTimeSeparator:
	tLCAmPmSpaceBetween:
rem	tRunExeCmd:
	tRunDoc:
	tOPXVersion:
	
	rem
	rem TESTS END HERE
	rem

	print
	print "All tests passed. Press any key to finish..."
	get
endp

proc tDbFind:
	local recnum&
	trap delete KTestFile$
	create KTestFile$+" FIELDS name TO test",A, name$
	A.name$="dummy"
	append
	append
	append
	A.name$="find this"
	append
	A.name$="dummy"
	append
	append
	append
	first
	recnum&=DBFind&:("find*")
	print "Record found was:",recnum&
	close
	delete KTestFile$
	if recnum&<>4
		raise 10
	endif
	print
endp

proc tDbFindField:
	local recnum&
	trap delete KTestFile$
	create KTestFile$+" FIELDS name1,name2,name3 TO test",A, name1$,name2$,name3$
	A.name1$="dummy"
	A.name2$="dummy"
	A.name3$="don't find this"
	append
	append
	append
	A.name2$="find this"
	append
	A.name2$="dummy"
	append
	A.name2$="find this"
	append
	A.name2$="dummy"
	append
	append
	append

	recnum&=DBFindField&:("*this*",1,2,KFindForwardsFromStart%)
	print "Record found was:",recnum&
	if recnum&<>4
		raise 20
	endif

	next
	recnum&=DBFindField&:("*this*",1,2,KFindForwards%)
	print "Record found was:",recnum&
	if recnum&<>6
		raise 21
	endif

	back
	recnum&=DBFindField&:("*this*",1,2,KFindBackwards%)
	print "Record found was:",recnum&
	if recnum&<>4
		raise 22
	endif

	recnum&=DBFindField&:("*this*",1,2,KFindBackwardsFromEnd%)
	print "Record found was:",recnum&
	if recnum&<>6
		raise 23
	endif

	close
	delete KTestFile$
	print
endp

proc tGetThreadIdFromCaption:
	local id&
	local prev&
	IF EXIST("Z:\System\Apps\PostCard\PostCard.app") rem MC218
		id&=GetThreadIdFromCaption&:("Desktop",prev&)
	ELSE
		id&=GetThreadIdFromCaption&:("System",prev&)
	ENDIF
	print "Shell ThreadId is:",id&
	if id&<=0
		raise 30
	endif
endp

proc tExternalPower:
	local power&
	power&=ExternalPower&:
	print "External power:",power&
	if power&>0 or power&<-1
		raise 40
	endif
endp

proc tLCNearestLanguageFile:
	local rsc$(255)
	rsc$=LCNearestLanguageFile$:("Z:\System\Data\OplR.rsc")
	print "Nearest language file:",rsc$
	if rsc$<>"Z:\System\Data\OplR.r01" and rsc$<>"Z:\System\Data\OplR.rsc"
		raise 50
	endif
endp

proc tLCLanguage:
	local lang&
	lang&=LCLanguage&:
	print "Language:",lang&
	if lang&<1 or lang&>24
		raise 60
	endif
endp

proc tOsVersionMajor:
	local ver&
	ver&=OSVersionMajor&:
	print "OS major version: ",ver&
	if ver&<>1
		raise 70
	endif
endp

proc tOsVersionMinor:
	local ver&
	ver&=OSVersionMinor&:
	print "OS minor version: ",ver&
endp

proc tOsVersionBuild:
	local ver&
	ver&=OSVersionBuild&:
	print "OS build version: ",ver&
endp

proc tRomVersionMajor:
	local ver&
	ver&=ROMVersionMajor&:
	print "Rom major version: ",ver&
	if ver&<>1
		raise 90
	endif
endp

proc tRomVersionMinor:
	local ver&
	ver&=ROMVersionMinor&:
	print "Rom minor version: ",ver&
	if ver&<0 or ver&>6
		raise 100
	endif
endp

proc tRomVersionBuild:
	local ver&
	ver&=ROMVersionBuild&:
	print "Rom build version: ",ver&
	if ver&<>1 and (ver&<113 or ver&>500)
		raise 110
	endif
endp

proc tGetFileSize:
	local size&,i%
	size&=GetFileSize&:("Z:\System\OPL\Const.oph")
	if size&<14000 or size&>20000
		raise 120
	endif
	BUSY "Testing multiple successive calls to GetFileSize&:",2
	DO
		i%=i%+1
		PRINT i%,"(";GetFileSize&:("C:\System\System.ini");")"
	UNTIL i%=2000
	BUSY OFF
endp

proc tDTDayNameFull:
	local name$(10)
	onerr tDTDayNameFull1::
	name$=DTDayNameFull$:(0)
	raise 130
tDTDayNameFull1::
	onerr off
	name$=DTDayNameFull$:(1)
	print "Day 1 is:",name$
	if name$<>"Monday"
		raise 131
	endif
	name$=DTDayNameFull$:(7)
	print "Day 7 is:",name$
	if name$<>"Sunday"
		raise 132
	endif
	onerr tDTDayNameFull2::
	name$=DTDayNameFull$:(8)
	raise 133
tDTDayNameFull2::
endp

proc tDTMonthNameFull:
	local name$(10)
	onerr tDTMonthNameFull1::
	name$=DTMonthNameFull$:(0)
	raise 140
tDTMonthNameFull1::
	onerr off
	name$=DTMonthNameFull$:(1)
	print "Month 1 is:",name$
	if name$<>"January"
		raise 131
	endif
	name$=DTMonthNameFull$:(12)
	print "Month 12 is:",name$
	if name$<>"December"
		raise 132
	endif
	onerr tDTMonthNameFull2::
	name$=DTMonthNameFull$:(13)
	raise 133
tDTMonthNameFull2::
endp

proc tDTIsLeapYear:
	local leap&
	leap&=DTIsLeapYear&:(1996)
	print "Leap year 1996:",leap&
	if leap&<>-1
		raise 150
	endif
	leap&=DTIsLeapYear&:(1997)
	print "Leap year 1997:",leap&
	if leap&<>0
		raise 151
	endif
	leap&=DTIsLeapYear&:(2000)
	print "Leap year 2000:",leap&
	if leap&<>-1
		raise 152
	endif
	leap&=DTIsLeapYear&:(-4)
	print "Leap year 4 BC:",leap&
	if leap&<>-1
		raise 153
	endif
endp

proc tLCDateSeparator:
	local sep$(1)
	sep$=LCDateSeparator$:(0)
	print "Date separators:",sep$;
	if sep$<>chr$(0)
		raise 160
	endif
	sep$=LCDateSeparator$:(1)
	print sep$;
	if sep$<>"/" AND Sep$<>"." AND Sep$<>"," AND Sep$<>"-" AND Sep$<>" "
		raise 161
	endif
	sep$=LCDateSeparator$:(2)
	print sep$;
	if sep$<>"/" AND Sep$<>"." AND Sep$<>"," AND Sep$<>"-" AND Sep$<>" "
		raise 162
	endif
	sep$=LCDateSeparator$:(3)
	print sep$
	if sep$<>chr$(0)
		raise 163
	endif
endp

proc tLCTimeSeparator:
	local sep$(1)
	sep$=LCTimeSeparator$:(0)
	print "Time separators:",sep$;
	if sep$<>chr$(0)
		raise 170
	endif
	sep$=LCTimeSeparator$:(1)
	print sep$;
	if sep$<>":" AND Sep$<>"-" AND Sep$<>"."
		raise 171
	endif
	sep$=LCTimeSeparator$:(2)
	print sep$;
	if sep$<>":" AND Sep$<>"-" AND Sep$<>"."
		raise 172
	endif
	sep$=LCTimeSeparator$:(3)
	print sep$
	if sep$<>chr$(0)
		raise 173
	endif
endp

proc tLCAmPmSpaceBetween:
	local space&
	space&=LCAmPmSpaceBetween&:
	if space&<>-1
		raise 180
	endif
endp

CONST KJVMPath$="C:\System\Programs\Java.exe"
CONST KJVMCmdLine$=""

PROC tRunExeCmd:
	PRINT "Running an exe with command line tail - thread:",RunExeWithCmd&:(KJVMPath$,KJVMCmdLine$)
ENDP

PROC tRunDoc:
LOCAL File$(255),Dia%,SwitchToIfRunning%
	SwitchToIfRunning%=KFalse%
	DO
		dINIT "Select document to run"
		dFILE File$,"Name,Folder,Disk",$100+$200
		dCHECKBOX SwitchToIfRunning%,"Switch to if running"
		dBUTTONS "Cancel",-(KKeyEsc% OR KDButtonNoLabel%),"OK",KKeyEnter% OR KDButtonNoLabel%
		LOCK ON
		Dia%=DIALOG
		LOCK OFF
		IF Dia%<>KKeyEnter%
			BREAK
		ENDIF
		PRINT "ThreadID =",RunDocument&:(File$,SwitchToIfRunning%)
	UNTIL 0
ENDP

PROC tOPXVersion:
	ONERR Skipped::
	PRINT "Version of Z:\System\OPX\System.opx =",HEX$(GetOPXVersion&:("Z:\System\OPX\System.opx"))
	PRINT "Version of Z:\System\OPX\Date.opx =",HEX$(GetOPXVersion&:("Z:\System\OPX\Date.opx"))
	PRINT "Version of Z:\System\OPX\Bmp.opx =",HEX$(GetOPXVersion&:("Z:\System\OPX\Bmp.opx"))
	GOTO Skipped2::
	Skipped::
	PRINT "Error (";ERR;") Perhaps this is a pre-ER5 machine?"
	Skipped2::
	ONERR OFF

	ONERR ZSysram1::
	PRINT "Version of Z:\System\OPX\Sysram1.opx =",HEX$(GetOPXVersion&:("Z:\System\OPX\Sysram1.opx"))
	GOTO ZSysram1_OK::
	ZSysram1::
	PRINT "Error (";ERR;")"
	ZSysram1_OK::
	ONERR OFF
	
	ONERR CSysram1::
	PRINT "Version of C:\System\OPX\Sysram1.opx =",HEX$(GetOPXVersion&:("C:\System\OPX\Sysram1.opx"))
	GOTO CSysram1_OK::
	CSysram1::
	PRINT "Error (";ERR;")"
	CSysram1_OK::
	ONERR OFF
	
	PRINT "Trying to get OPX version of non OPX file..."
	ONERR Toolbar::
	PRINT "Version of Z:\System\OPL\Toolbar.opo =",HEX$(GetOPXVersion&:("Z:\System\OPL\Toolbar.opo"))
	GOTO Toolbar_OK::
	Toolbar::
	PRINT "Error (";ERR;")"
	Toolbar_OK::
	ONERR OFF
ENDP